'A reference to the Phidget22.NET.dll must be added to new projects in VB.Net 
'From the "Project" menu select "Add Reference" 
'From the "Add Reference" window select the "Browse" tab 
'Browse to the directory you installed the Phidgets library to 
'The default is "C:\Program Files\Phidgets" 
'Select "Phidget22.NET.dll" and click "OK" 
'To view objects that have been added, select the "View" menu 
'Select "Object Browser" 
'Then expand the Phidget22.NET.dll item 


'********************************************
'FAILSAFE CODE DOES NOT EXIST YET SINCE THERE IS NO WORKING VINT STEPPER CONTROLLER TO TEST WITH AND THE USB PHIDGET STEPPERS DONT USE IT AT ALL
'THIS WILL NEED TO BE ADDED ONCE WE HAVE A WORKING VINT DEVICE FOR IT.
'********************************************

Imports Phidget22
Imports Phidget22.Events

Public Class Form1
    Dim WithEvents device As Phidget22.Stepper
    Dim open As ExampleUtils.ExampleUtils.CommandLineOpen
    Dim errorBox As ErrorEventBox

    Public Sub New()
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Public Sub New(ByVal commandLine As String())
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        open.commandLine = commandLine
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        errorBox = New ErrorEventBox(Me)
        device = New Phidget22.Stepper()

        'open the device
        Dim phidgetParameters As ExampleUtils.commandLineData = open.parseCmdLine()

        Try 'set all the values grabbed from command line.  these values have defaults that are set in ExampleUtils.vb, you can check there to see them
            device.Channel = phidgetParameters.Channel 'selects the channel on the device to open
            device.DeviceSerialNumber = phidgetParameters.SerialNumber 'selects the device or hub to open
            device.HubPort = phidgetParameters.HubPort 'selects th eport on the hub to open
            device.IsHubPortDevice = phidgetParameters.isHubPortDevice 'is the device a port on a vint hub?

            If phidgetParameters.isRemote Then 'are we trying to open a remote device?
                device.IsRemote = True
                Net.EnableServerDiscovery(ServerType.Device) 'turn on network scan
                If phidgetParameters.Password <> vbNullString And phidgetParameters.ServerName <> vbNullString Then
                    Net.SetServerPassword(phidgetParameters.ServerName, phidgetParameters.Password)
                End If
            Else
                device.IsLocal = True
            End If

            device.Open() 'open the device specified by the above parameters
        Catch ex As PhidgetException
            errorBox.addMessage("Error opening the device: " + ex.Message)
        End Try
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Application.DoEvents()
        If device.Attached Then
            device.Close()
        End If
    End Sub

#Region "Phidget event handlers"
    Private Sub device_Attach(ByVal sender As Object, ByVal e As Phidget22.Events.AttachEventArgs) Handles device.Attach
        Dim attachedDevice As Stepper = CType(sender, Stepper)
        PhidgetInfoBox1.FillPhidgetInfo(attachedDevice)

        'set up the limits for the various controls etc...

        Select Case (attachedDevice.DeviceID)
            Case DeviceID.PN_1062
                tbCurrentLimit1.Visible = False
                tbCurrentLimit2.Visible = False
                minCurrLbl1.Visible = False
                minCurrLbl2.Visible = False
                maxCurrLbl1.Visible = False
                maxCurrLbl2.Visible = False
                currLimitLbl1.Visible = False
                currLimitLbl2.Visible = False
                txtCurrentLimit1.Visible = False
                txtCurrentLimit2.Visible = False

            Case Else
                tbCurrentLimit1.Visible = True
                tbCurrentLimit2.Visible = True
                minCurrLbl1.Visible = True
                minCurrLbl2.Visible = True
                maxCurrLbl1.Visible = True
                maxCurrLbl2.Visible = True
                currLimitLbl1.Visible = True
                currLimitLbl2.Visible = True
                txtCurrentLimit1.Visible = True
                txtCurrentLimit2.Visible = True
        End Select

        tbTargetPosition.Value = 0

        setupMaxMin(attachedDevice)
        updateValues(attachedDevice)

        enBtn.Text = If(attachedDevice.Engaged, "Disengage", "Engage")

        statusBox.Visible = True
        outputSettings.Visible = True
    End Sub

    Sub setSliderValue(tb As TrackBar, val As Double, min As Double, max As Double)
        val -= min
        val = (val * (tb.Maximum - tb.Minimum)) / (max - min)
        tb.Value = CType(Math.Round(val), Integer)
    End Sub

    Public Function getSliderValue(tb As TrackBar, min As Double, max As Double) As Double
        Dim val As Double = tb.Value - tb.Minimum
        val = (val * (max - min)) / (tb.Maximum - tb.Minimum) + min
        Return val
    End Function

    Sub setupMaxMin(stepper As Stepper)
        Try
            If outputSettings.SelectedTab.Equals(tabPage1) Then
                minTargetPositionLbl.Text = tbTargetPosition.Minimum.ToString()
                maxTargetPositionLbl.Text = tbTargetPosition.Maximum.ToString()

                minAccelLbl1.Text = stepper.MinAcceleration.ToString()
                maxAccelLbl1.Text = stepper.MaxAcceleration.ToString()

                minVelocityLbl1.Text = stepper.MinVelocityLimit.ToString()
                maxVelocityLbl1.Text = stepper.MaxVelocityLimit.ToString()
                If stepper.DeviceID <> DeviceID.PN_1062 Then
                    minCurrLbl1.Text = stepper.MinCurrentLimit.ToString() + " A"
                    maxCurrLbl1.Text = stepper.MaxCurrentLimit.ToString() + " A"
                End If
            End If
            If outputSettings.SelectedTab.Equals(tabPage2) Then
                minAccelLbl2.Text = stepper.MinAcceleration.ToString()
                maxAccelLbl2.Text = stepper.MaxAcceleration.ToString()

                minVelocityLbl2.Text = stepper.MinVelocityLimit.ToString()
                maxVelocityLbl2.Text = stepper.MaxVelocityLimit.ToString()
                If stepper.DeviceID <> DeviceID.PN_1062 Then
                    minCurrLbl2.Text = stepper.MinCurrentLimit.ToString() + " A"
                    maxCurrLbl2.Text = stepper.MaxCurrentLimit.ToString() + " A"
                End If
            End If
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting mins/maxs: " + ex.Message)
        End Try
    End Sub


    Private Sub device_Detach(ByVal sender As Object, ByVal e As Phidget22.Events.DetachEventArgs) Handles device.Detach
        PhidgetInfoBox1.Clear()

        statusBox.Visible = False
        outputSettings.Visible = False
    End Sub

    Private Sub device_Error(ByVal sender As Object, ByVal e As Phidget22.Events.ErrorEventArgs) Handles device.Error
        errorBox.addMessage(e.Description)
    End Sub

    Private Sub device_PositionUpdate(ByVal sender As Object, ByVal e As Phidget22.Events.StepperPositionChangeEventArgs) Handles device.PositionChange
        txtPosition.Text = e.Position.ToString()
    End Sub

    Private Sub device_VelocityUpdate(ByVal sender As Object, ByVal e As Phidget22.Events.StepperVelocityChangeEventArgs) Handles device.VelocityChange
        txtVelocity.Text = e.Velocity.ToString()
    End Sub

    Private Sub updateValues(stepper As Stepper)

        Try
            txtPosition.Text = stepper.Position.ToString()
        Catch
            txtPosition.Text = "N/A"
        End Try

        Try
            txtVelocity.Text = stepper.Velocity.ToString()
        Catch
            txtVelocity.Text = "N/A"
        End Try

        If outputSettings.SelectedTab.Equals(tabPage1) Then
            Try
                setSliderValue(tbAcceleration1, stepper.Acceleration, stepper.MinAcceleration, stepper.MaxAcceleration)
                txtAcceleration1.Text = stepper.Acceleration.ToString()
            Catch
                txtAcceleration1.Text = "N/A"
            End Try

            Try
                setSliderValue(tbVelocityLimit1, stepper.VelocityLimit, stepper.MinVelocityLimit, stepper.MaxVelocityLimit)
                txtVelocityLimit1.Text = stepper.VelocityLimit.ToString()
            Catch
                txtVelocityLimit1.Text = "N/A"
            End Try

            Try
                tbTargetPosition.Value = CType(Math.Round(stepper.TargetPosition), Single)
                txtTargetPosition.Text = stepper.TargetPosition.ToString()
            Catch
                txtTargetPosition.Text = "N/A"
            End Try
            Try
                setSliderValue(tbCurrentLimit1, stepper.CurrentLimit, stepper.MinCurrentLimit, stepper.MaxCurrentLimit)
                txtCurrentLimit1.Text = stepper.CurrentLimit.ToString() + " A"
            Catch
                txtCurrentLimit1.Text = "N/A"

            End Try
        End If
        If (outputSettings.SelectedTab.Equals(tabPage2)) Then
            Try
                setSliderValue(tbAcceleration2, stepper.MinAcceleration, stepper.MinAcceleration, stepper.MaxAcceleration)
                txtAcceleration2.Text = stepper.Acceleration.ToString()
            Catch
                txtAcceleration2.Text = "N/A"
            End Try
            Try
                setSliderValue(tbVelocityLimit2, stepper.VelocityLimit, stepper.MinVelocityLimit, stepper.MaxVelocityLimit)
                txtVelocityLimit2.Text = stepper.VelocityLimit.ToString()
            Catch
                txtVelocityLimit2.Text = "N/A"
            End Try
            Try
                setSliderValue(tbCurrentLimit2, stepper.CurrentLimit, stepper.MinCurrentLimit, stepper.MaxCurrentLimit)
                txtCurrentLimit2.Text = stepper.CurrentLimit.ToString() + " A"
            Catch
                txtCurrentLimit2.Text = "N/A"
            End Try
        End If
    End Sub

#End Region

#Region "Motor Control Handlers"
    'change between run mode and position mode
    Private Sub tabControl_SelectedIndexChanged(sender As Object, e As EventArgs) Handles outputSettings.SelectedIndexChanged
        Try
            If outputSettings.SelectedIndex = 0 Then
                device.ControlMode = StepperControlMode.Step
            Else
                device.ControlMode = StepperControlMode.Run
            End If
            setupMaxMin(device)
            updateValues(device)
        Catch ex As Exception
            errorBox.addMessage("Error setting control mode: " + ex.Message)
        End Try
    End Sub

    Private Sub tbTargetPosition_Scroll(sender As Object, e As EventArgs) Handles tbTargetPosition.Scroll
        'set the target position in position mode
        Try
            device.TargetPosition = tbTargetPosition.Value
            txtTargetPosition.Text = device.TargetPosition.ToString()
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting target position: " + ex.Message)
        End Try
    End Sub

    'adjust the amount of current the controller can deliver
    Private Sub tbCurrentLimit1_Scroll(sender As Object, e As EventArgs) Handles tbCurrentLimit1.Scroll
        Try
            device.CurrentLimit = getSliderValue(tbCurrentLimit1, device.MinCurrentLimit, device.MaxCurrentLimit)
            txtCurrentLimit1.Text = device.CurrentLimit.ToString() + " A"
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting current limit: " + ex.Message)
        End Try
    End Sub

    Private Sub tbCurrentLimit2_Scroll(sender As Object, e As EventArgs)
        Try
            device.CurrentLimit = getSliderValue(tbCurrentLimit2, device.MinCurrentLimit, device.MaxCurrentLimit)
            txtCurrentLimit2.Text = device.CurrentLimit.ToString() + " A"
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting current limit: " + ex.Message)
        End Try
    End Sub

    'set the acceleration for when the controller is ramping up or down
    Private Sub tbAcceleration1_Scroll(sender As Object, e As EventArgs) Handles tbAcceleration1.Scroll
        Try
            device.Acceleration = getSliderValue(tbAcceleration1, device.MinAcceleration, device.MaxAcceleration)
            txtAcceleration1.Text = device.Acceleration.ToString("F0")
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting acceleration: " + ex.Message)
        End Try
    End Sub

    Private Sub tbAcceleration2_Scroll(sender As Object, e As EventArgs)
        Try
            device.Acceleration = getSliderValue(tbAcceleration2, device.MinAcceleration, device.MaxAcceleration)
            txtAcceleration2.Text = device.Acceleration.ToString("F0")
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting acceleration: " + ex.Message)
        End Try
    End Sub

    'set the velocity limit.  the controller will accelerate until it reaches this limit and then decellerate as it approaches the target position
    'in run mode the motor will be driven at this velocity constantly until stopped
    Private Sub tbVelocityLimit1_Scroll(sender As Object, e As EventArgs) Handles tbVelocityLimit1.Scroll
        Try
            device.VelocityLimit = getSliderValue(tbVelocityLimit1, device.MinVelocityLimit, device.MaxVelocityLimit)
            txtVelocityLimit1.Text = device.VelocityLimit.ToString("F0")
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting velocity limit: " + ex.Message)
        End Try
    End Sub

    Private Sub tbVelocityLimit2_Scroll(sender As Object, e As EventArgs) Handles tbVelocityLimit2.Scroll
        Try
            device.VelocityLimit = getSliderValue(tbVelocityLimit2, device.MinVelocityLimit, device.MaxVelocityLimit)
            txtVelocityLimit2.Text = device.VelocityLimit.ToString("F0")
        Catch ex As PhidgetException
            errorBox.addMessage("Error setting velocity limit: " + ex.Message)
        End Try
    End Sub

    'set the position of the motor to 0.  this doesn't move the motor, just resets it's internal position counter to 0 (position mode only)
    Private Sub btnSetZeroPosition_Click(sender As Object, e As EventArgs)
        device.AddPositionOffset(-device.Position)
    End Sub

    'stop the motor (run mode only)
    Private Sub StopButton_Click(sender As Object, e As EventArgs) Handles StopButton.Click
        Try
            tbVelocityLimit2.Value = 0
            device.VelocityLimit = 0
            txtVelocityLimit2.Text = "0"
        Catch ex As PhidgetException
            errorBox.addMessage("Error stopping motor: " + ex.Message)
        End Try
    End Sub
#End Region

    'engage the motor.  this will apply power to the motor and begin issuing step commands assuming a target position or target velocity has been set in either position or run more respectively
    Private Sub enBtn_Click(sender As Object, e As EventArgs) Handles enBtn.Click
        'toggle enable
        Try
            If device.Engaged = False Then
                device.Engaged = True
                enBtn.Text = "Disengage"
            ElseIf device.Engaged = True
                device.Engaged = False
                enBtn.Text = "Engage"
            End If
        Catch ex As PhidgetException
            errorBox.addMessage("Error enabling: " + ex.ToString())
        End Try
    End Sub

    'set the rescale factor.  this controls the effective units of motor position and motor velocity
    'for example, a stepper motor with a 1.8 step angle takes 200 steps to do a full rotation.
    'the phidget stepper controllers output in 1/16th step increments meaning if you set the rescale factor to 
    '200*16, a position of 1 would equate to 360.  if you set the rescale factor to 1.8*16 a position of 1 would
    'be 1.  this functionality just allows the user to rescale the units used in the library to something
    'more easily visualized
    Private Sub txtRescaleFactor_KeyDown(sender As Object, e As KeyEventArgs) Handles txtRescaleFactor.KeyDown
        If e.KeyCode = Keys.Enter Then
            Try
                device.RescaleFactor = Double.Parse(txtRescaleFactor.Text)
            Catch ex As Exception
                errorBox.addMessage("Error setting rescale factor: " + ex.Message)
                txtRescaleFactor.Text = "1"
            End Try
            e.SuppressKeyPress = True
        End If
    End Sub
End Class



